﻿#ifndef HCBIZTRANS_H
#define HCBIZTRANS_H
#include <string>
#include "hcbiztrans_global.h"
//这个是给业务层使用的。
//用户实例化这传输层给对应的业务层。
//

class HCBizTransSender{
public:
    //纯消息发送到服务器。对于业务封装的处理由业务层处理。
    virtual void sendTextMessage(const std::string & data);
    virtual ~HCBizTransSender();
};
class HCBizTransProcesser{
public:
    virtual void onProcess(const std::string & type,const std::string & data);
    virtual ~HCBizTransProcesser();
};
class HC_BIZSO_API HCBizTrans:public HCBizTransSender
{
public:

    //有过有可能 可以使用外部的加解密函数。
    //public:
    //class Cryptor{
    //public:
    //    void AddRef() const;

    //    int Encrypt(cricket::MediaType media_type,
    //                uint32_t ssrc,
    //                rtc::ArrayView<const uint8_t> additional_data,
    //                rtc::ArrayView<const uint8_t> frame,
    //                rtc::ArrayView<uint8_t> encrypted_frame,
    //                size_t* bytes_written)  ;
    //    int Decrypt(cricket::MediaType media_type,
    //                          const std::vector<uint32_t>& csrcs,
    //                          rtc::ArrayView<const uint8_t> additional_data,
    //                          rtc::ArrayView<const uint8_t> encrypted_frame,
    //                          rtc::ArrayView<uint8_t> frame,
    //                          size_t* bytes_written);

    //    size_t GetMaxCiphertextByteSize(cricket::MediaType media_type,
    //                                    size_t frame_size);

    //    size_t GetMaxPlaintextByteSize(cricket::MediaType media_type,
    //                                               size_t encrypted_frame_size);
    //};
public:
    /*!
     * \brief 这个是给app层使用的api回调。
     * 主要是服务器状态，登录状态的通知.
     */
    class HC_BIZSO_API Listener{
    public:
        virtual void onTransCommond(const std::string & type,const std::string & data){}
        virtual void onTransNotify(const std::string & type,const std::string &data){}
        virtual ~Listener(){}
    };

    class HC_BIZSO_API Process {
    public:
        virtual void onProcess(const std::string & type,const std::string & data);
        virtual ~Process();
    };
public:
    HCBizTrans();
    bool canSend();
    virtual bool enableCrypto(bool enable);
    bool  sendCommond(const std::string  & type ,const std::string & data);
    //用于app的监听回调
    virtual void setAppListener(HCBizTrans::Listener * l);
    //用于业务处理调用，多次添加。
    virtual void addBizProcess(HCBizTrans::Process * process);
    virtual void init(const std::string & server);
    void loginByOAuth(const std::string & server,const std::string & username ,const std::string & password);
    void loginBytoken(const std::string &serve, const  std::string & token);
    void loginBySAML(const std::string &server ,const std::string & token);
    virtual void login(const std::string & server,const std::string & username ,const std::string & password);
    virtual void logout();
    void sendTextMessage(const std::string & data) ;
    virtual void sendBinary(const unsigned char * data,int size);
    virtual ~HCBizTrans();
};

#endif // HCBIZTRANS_H
